"""
Django settings for core project.

Generated by 'django-admin startproject' using Django 4.1.2.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

import os
from pathlib import Path

from dotenv import load_dotenv

from envparse import env

import sentry_sdk
from sentry_sdk.integrations.django import DjangoIntegration
from sentry_sdk.integrations.logging import ignore_logger

load_dotenv()

API_VERSION = '0.1.0'

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

env.read_envfile()

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = env("SECRET_KEY", cast=str, default='sdjfslkfjslkfjsk')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = env("DEBUG", cast=bool, default=True)

#ALLOWED_HOSTS = os.getenv("ALLOWED_HOSTS")
ALLOWED_HOSTS = ['*']
DOMAIN_NAME = env("DOMAIN_NAME", cast=str, default='sdjfslkfjslkfjsk')

# Sentry config
LOCAL_HOST_IP = '127.0.0.1'

if not DOMAIN_NAME == LOCAL_HOST_IP:
    sentry_sdk.init(
        dsn=env('SENTRY_URL', cast=str,
                default='https://4fa2ef30d77c4d5ca46fcf0a7e403e01@sentry.foxdev.in/2'),
        integrations=[DjangoIntegration()],
        traces_sample_rate=1.0,
        send_default_pii=True,

    )
    #sentry_sdk.capture_message('Sentry initialized')

# Application definition

INSTALLED_APPS = [
    'jazzmin',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'phonenumber_field',
    'celery',
    'django_celery_beat',
    'rest_framework',
    'django_extensions',
    'djmoney',
    'django_cleanup.apps.CleanupConfig',
    'storages',
    'drf_yasg',
    'silk'
]

PROJECT_APPS = ['apps.auth_app.apps.AuthAppConfig',
                'apps.user_app.apps.UserAppConfig',
                'apps.notification_app.apps.NotificationAppConfig',
                'apps.place_app.apps.PlaceAppConfig',
                'apps.discussion_app.apps.DiscussionAppConfig',
                'apps.payment_app.apps.PaymentAppConfig',
                'apps.admin_pages_app.apps.AdminPagesAppConfig',
                'apps.rabbitmq_app.apps.RabbitmqAppConfig',
                'apps.geolocations_app.apps.GeolocationsAppConfig'
                ]

INSTALLED_APPS += PROJECT_APPS

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

if DEBUG:
    MIDDLEWARE.append('silk.middleware.SilkyMiddleware')

ROOT_URLCONF = 'core.urls'

TEMPLATE_DIR = os.path.join(BASE_DIR, "templates")

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [TEMPLATE_DIR],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'core.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.0/ref/settings/#databases

DB_ENGINE = env('DB_ENGINE', cast=str, default='')

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql',
        'NAME': env('POSTGRES_DB', cast=str, default=''),
        'USER': env('POSTGRES_USER', cast=str, default=''),
        'PASSWORD': env('POSTGRES_PASSWORD', cast=str, default=''),
        'HOST': env('POSTGRES_HOST', cast=str, default=''),
        'PORT': env('POSTGRES_PORT', cast=str, default='')
    }
}

# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

AUTH_USER_MODEL = 'user_app.CustomUser'

# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/

#STATIC_URL = 'static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static')


# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

# Redis config
REDIS_URL = env("REDIS_URL", cast=str, default='redis')
REDIS_PORT = env("REDIS_PORT", cast=int, default=6379)

# REDIS related settings
BROKER_TRANSPORT_OPTIONS = {'visibility_timeout': 3600}
CELERY_TASK_TRACK_STARTED = True
CELERY_TIMEZONE = 'UTC'
CELERY_ACCEPT_CONTENT = ['application/json']
CELERY_TASK_SERIALIZER = 'json'
CELERY_RESULT_SERIALIZER = 'json'
CELERY_BROKER_URL = env("CELERY_BROKER", cast=str,
                        default="redis_celery://redis_celery:6379/0")
CELERY_RESULT_BACKEND = env(
    "CELERY_BACKEND", cast=str, default="redis_celery://redis_celery:6379/0")
CELERY_ENABLE_UTC = True
CELERY_BEAT_SCHEDULER = 'django_celery_beat.schedulers:DatabaseScheduler'

TIMEOUT_CACHE = env('TIMEOUT_CACHE', cast=int, default=1)

CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.db.DatabaseCache',
        'LOCATION': 'cache_table',
        'TIMEOUT': TIMEOUT_CACHE,
    },
}

REST_FRAMEWORK = {
    'DEFAULT_RENDERER_CLASSES': [
        # TODO configure DEFAULT_RENDERER_CLASSES
        'djangorestframework_camel_case.render.CamelCaseJSONRenderer',
        'rest_framework.renderers.JSONRenderer',
        # 'rest_framework.renderers.BrowsableAPIRenderer',
    ],
    'DEFAULT_AUTHENTICATION_CLASSES': (
        # TODO Add your authentication backend and configure existing backends
        'apps.auth_app.backends.JWTHeaderAuthentication',
        'rest_framework.authentication.BasicAuthentication',
        'rest_framework.authentication.TokenAuthentication',
        'rest_framework.authentication.SessionAuthentication',
    ),
    'DEFAULT_FILTER_BACKEND': (
        'django_filters.rest_framework.DjangoFilterBackend',
    ),
    # TODO configure DEFAULT_PAGINATION_CLASS
    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.LimitOffsetPagination',
    'PAGE_SIZE': 10, 

    'DEFAULT_PARSER_CLASSES': (
        # If you use MultiPartFormParser or FormParser, we also have a camel case version
        'djangorestframework_camel_case.parser.CamelCaseFormParser',
        'djangorestframework_camel_case.parser.CamelCaseMultiPartParser',
        'djangorestframework_camel_case.parser.CamelCaseJSONParser',
        # Any other parsers
    ),
    'EXCEPTION_HANDLER': 'utils.exception_handler.custom_exception_handler',
}

# if DEBUG:
#     SPECTACULAR_SETTINGS = {
#         'TITLE': 'Smp API',
#         'DESCRIPTION': 'Simposiy project',
#         'VERSION': '1.0.0',
#         'SERVE_INCLUDE_SCHEMA': False,
#         # OTHER SETTINGS
#     }
#     INSTALLED_APPS.append('drf_spectacular')
#     REST_FRAMEWORK['DEFAULT_SCHEMA_CLASS'] = 'drf_spectacular.openapi.AutoSchema'


# Firebase config
GOOGLE_APPLICATION_CREDENTIALS = env(
    "GOOGLE_APPLICATION_CREDENTIALS", cast=str, default='./simposiy_app_private_key.json')
GOOGLE_APPLICATION_CREDENTIALS_DIR: str = os.path.join(
    BASE_DIR, GOOGLE_APPLICATION_CREDENTIALS)

FIREBASE_CONFIG = {
    'type': env('FIREBASE_TYPE', cast=str, default=''),
    'project_id': env('FIREBASE_PROJECT_ID', cast=str, default=''),
    'private_key_id': env('FIREBASE_PRIVATE_KEY_ID', cast=str, default=''),
    'private_key': env('FIREBASE_PRIVATE_KEY', cast=str, default=''),
    'client_email': env('FIREBASE_CLIENT_EMAIL', cast=str, default=''),
    'client_id': env('FIREBASE_CLIENT_ID', cast=str, default=''),
    'auth_uri': env('FIREBASE_AUTH_URI', cast=str, default=''),
    'token_uri': env('FIREBASE_TOKEN_URI', cast=str, default=''),
    'auth_provider_x509_cert_url': env(
        'FIREBASE_AUTH_PROVIDER_X509_CERT_URL', cast=str, default=''),
    'client_x509_cert_url': env('FIREBASE_CLIENT_X509_CERT_URL', cast=str, default=''),
}

# Authorization config
JWT_EXP_DAYS = env('JWT_EXP_DAYS', cast=int, default=1)
AUTH_USER_MODEL = 'user_app.CustomUser'
ACCOUNT_USER_MODEL_USERNAME_FIELD = None
ACCOUNT_USERNAME_REQUIRED = False
JWT_SECRET = env('JWT_SECRET', cast=str, default='')
JWT_TTL = env('JWT_TTL', cast=int, default=60 * 24 * 7)  # minites

REFRESH_TOKEN_TTL = env('REFRESH_TOKEN_TTL', cast=int,
                        default=JWT_TTL*5)  # minites

# OTP SMS config
OTP_SMS_TTL = env('OTP_SMS_TTL', cast=int, default=60)  # seconds
CAN_SEND_SMS = env('CAN_SEND_SMS', cast=bool, default=False)
SMS_API_ID = env('SMS_API_ID', cast=str, default='')
SMS_FROM = env('SMS_FROM', cast=str, default='')

# Stripe config
STRIPE_PUBLIC_KEY = env('STRIPE_PUBLIC_KEY', cast=str, default='')
STRIPE_SECRET_KEY = env('STRIPE_SECRET_KEY', cast=str, default='')
STRIPE_WEBHOOK_SECRET = env('STRIPE_WEBHOOK_SECRET', cast=str, default='')
STRIPE_CONNECTED_ACC_WEBHOOK_SECRET = env('STRIPE_CONNECTED_ACC_WEBHOOK_SECRET', cast=str, default='')


if DOMAIN_NAME == LOCAL_HOST_IP:
    STRIPE_PUBLIC_KEY = env('LOCAL_STRIPE_PUBLIC_KEY', cast=str, default='')
    STRIPE_SECRET_KEY = env('LOCAL_STRIPE_SECRET_KEY', cast=str, default='')
    STRIPE_WEBHOOK_SECRET = env('LOCAL_STRIPE_WEBHOOK_SECRET', cast=str, default='')


# JAZZMIN configs
JAZZMIN_SETTINGS = {
    "related_modal_active": True,
    "site_title": "SIMPOSIY",

    # Title on the login screen (19 chars max) (defaults to current_admin_site.site_header if absent or None)
    "site_header": "Simposiy",

    # Title on the brand (19 chars max) (defaults to current_admin_site.site_header if absent or None)
    "site_brand": "SIMPOSIY",
    "site_logo_classes": "",

    # Logo to use for your site, must be present in static files, used for brand on top left
    "site_logo": "auth_app/logo.png",

    # Welcome text on the login screen
    "welcome_sign": "Welcome to SIMPOSIY",

    # List of apps (and/or models) to base side menu ordering off of (does not need to contain all apps/models)
    "order_with_respect_to": ['auth_app', 'user_app', 'discussion_app', 'place_app', 'geolocations_app', 'notification_app']
}

JAZZMIN_UI_TWEAKS = {
    "navbar_small_text": False,
    "footer_small_text": False,
    "body_small_text": False,
    "brand_small_text": False,
    "brand_colour": "navbar-dark",
    "accent": "text-dark",
    # "navbar": "navbar-dark",
    "no_navbar_border": False,
    "navbar_fixed": False,
    "layout_boxed": False,
    "footer_fixed": False,
    "sidebar_fixed": False,
    # "sidebar": "sidebar-light-info",
    "sidebar_nav_small_text": False,
    "sidebar_disable_expand": False,
    "sidebar_nav_child_indent": False,
    "sidebar_nav_compact_style": False,
    "sidebar_nav_legacy_style": False,
    "sidebar_nav_flat_style": False,
    "theme": "flatly",
    # "dark_mode_theme": None,
    "button_classes": {
        "primary": "btn-primary",
        "secondary": "btn-secondary",
        "info": "btn-info",
        "warning": "btn-warning",
        "danger": "btn-danger",
        "success": "btn-outline-success",
    },
}

# AWS s3 config
AWS_ACCESS_KEY_ID = env('AWS_ACCESS_KEY_ID', cast=str, default='')
AWS_SECRET_ACCESS_KEY = env('AWS_SECRET_ACCESS_KEY', cast=str, default='')
AWS_STORAGE_BUCKET_NAME = env('AWS_STORAGE_BUCKET_NAME', cast=str, default='')
AWS_S3_CUSTOM_DOMAIN = f'{AWS_STORAGE_BUCKET_NAME}.s3.amazonaws.com'
AWS_S3_OBJECT_PARAMETERS = {
    'CacheControl': 'max-age=86400',
}
AWS_STATIC_LOCATION = env("AWS_STATIC_LOCATION", cast=str, default='')

#STATIC_URL = f'https://{AWS_S3_CUSTOM_DOMAIN}/{AWS_STATIC_LOCATION}/'
STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static')

AWS_PUBLIC_MEDIA_LOCATION = 'media/public'
AWS_PDF_LOCATION = 'media/pdf-files'
DB_USER = env('POSTGRES_USER', cast=str, default='')

if DOMAIN_NAME == LOCAL_HOST_IP and DB_USER == 'postgres':
    AWS_PUBLIC_MEDIA_LOCATION = 'media/local-test'
    AWS_PDF_LOCATION = 'media/local-pdf-files'
    
DEFAULT_FILE_STORAGE = 'storages.backends.s3boto3.S3Boto3Storage'


# SWAGGER configs
SWAGGER_SETTINGS = {
    'SECURITY_DEFINITIONS': {
        'Bearer': {
            'type': 'apiKey',
            'name': 'Authorization',
            'in': 'header'
        }
    }
}


# RabbitMQ  configs

RABBITMQ_APP = os.getenv('RABBITMQ_APP')
RABBITMQ_APP_GROUP = os.getenv('RABBITMQ_APP_GROUP')
RABBITMQ_DEFAULT_PASS = os.getenv('RABBITMQ_DEFAULT_PASS')
RABBITMQ_DEFAULT_USER = os.getenv('RABBITMQ_DEFAULT_USER')
RABBITMQ_DELAY = os.getenv('RABBITMQ_DELAY')
RABBITMQ_EXCHANGE = os.getenv('RABBITMQ_EXCHANGE')
RABBITMQ_HOST = os.getenv('RABBITMQ_HOST')
RABBITMQ_MAX_RETRIES = os.getenv('RABBITMQ_MAX_RETRIES')
RABBITMQ_PORT = os.getenv('RABBITMQ_PORT')
RABBITMQ_PREFIX = os.getenv('RABBITMQ_PREFIX')
RABBITMQ_QUEUE_LENGTH = os.getenv('RABBITMQ_QUEUE_LENGTH')
RABBITMQ_SERVER_ADDITIONAL_ERL_ARGS = os.getenv('RABBITMQ_SERVER_ADDITIONAL_ERL_ARGS')
RABBITMQ_VIRTUAL_HOST = os.getenv('RABBITMQ_VIRTUAL_HOST')

# Inbound Exchange
RABBITMQ_CONSUMER_PASSWORD = os.getenv('RABBITMQ_CONSUMER_PASSWORD')
RABBITMQ_CONSUMER_USER = os.getenv('RABBITMQ_CONSUMER_USER')
RABBITMQ_PRODUCER_PASSWORD = os.getenv('RABBITMQ_PRODUCER_PASSWORD')
RABBITMQ_PRODUCER_USER = os.getenv('RABBITMQ_PRODUCER_USER')

RABBITMQ_CONSUMER_PASSWORD_OUT = os.getenv(
    'RABBITMQ_CONSUMER_PASSWORD_OUT'
)
RABBITMQ_CONSUMER_USER_OUT = os.getenv(
    'RABBITMQ_CONSUMER_USER_OUT'
        )

VIRTUAL_HOST = (
    f'{RABBITMQ_PREFIX}.'
    f'{RABBITMQ_APP_GROUP}.'
    f'{RABBITMQ_APP}.'
    f'{RABBITMQ_VIRTUAL_HOST}'
)

EXCHANGE_INBOUND = (
    f'{RABBITMQ_PREFIX}.'
    f'{RABBITMQ_APP_GROUP}.'
    f'{RABBITMQ_APP}.dlx.inbound'
)

EXCHANGE_OUTBOUND = (
    f'{RABBITMQ_PREFIX}.'
    f'{RABBITMQ_APP_GROUP}.'
    f'{RABBITMQ_APP}.dlx.outbound'
)

EXCHANGE_PUSH_NOTIFICATION_INBOUND = (
    f'{RABBITMQ_PREFIX}.'
    f'{RABBITMQ_APP_GROUP}.'
    f'{RABBITMQ_APP}.push.notification.dlx.inbound'
)
